Index: /pjproject/trunk/Makefile
===================================================================
--- /pjproject/trunk/Makefile	(revision 314)
+++ /pjproject/trunk/Makefile	(revision 315)
@@ -16,5 +16,5 @@
 		    exit 1; \
 		fi; \
-	   fi \
+	   fi; \
 	done
 
Index: /pjproject/trunk/pjlib-util/src/pjlib-util/errno.c
===================================================================
--- /pjproject/trunk/pjlib-util/src/pjlib-util/errno.c	(revision 314)
+++ /pjproject/trunk/pjlib-util/src/pjlib-util/errno.c	(revision 315)
@@ -99,7 +99,7 @@
     /* Error not found. */
     errstr.ptr = buf;
-    errstr.slen = pj_snprintf(buf, bufsize, 
-			      "Unknown error %d",
-			      statcode);
+    errstr.slen = pj_ansi_snprintf(buf, bufsize, 
+				   "Unknown error %d",
+				   statcode);
 
     return errstr;
Index: /pjproject/trunk/pjlib/include/pj/compat/cc_msvc.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/cc_msvc.h	(revision 314)
+++ /pjproject/trunk/pjlib/include/pj/compat/cc_msvc.h	(revision 315)
@@ -34,4 +34,9 @@
 #define PJ_CC_VER_3	    0
 
+/* Disable CRT deprecation warnings. */
+#if PJ_CC_VER_1 >= 8
+#   define _CRT_SECURE_NO_DEPRECATE
+#endif
+
 #pragma warning(disable: 4127) // conditional expression is constant
 #pragma warning(disable: 4611) // not wise to mix setjmp with C++
Index: /pjproject/trunk/pjlib/include/pj/compat/string.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/compat/string.h	(revision 314)
+++ /pjproject/trunk/pjlib/include/pj/compat/string.h	(revision 315)
@@ -27,5 +27,5 @@
 
 #if defined(PJ_HAS_STRING_H) && PJ_HAS_STRING_H != 0
-#  include <string.h>
+#   include <string.h>
 #else
 
@@ -36,23 +36,20 @@
 
 #if defined(_MSC_VER)
-#  define strcasecmp	stricmp
-#  if defined(PJ_WIN32_WINCE) && PJ_WIN32_WINCE!=0
+#   include <stdio.h>
+#   define strcasecmp	_stricmp
 #   define strncasecmp	_strnicmp
-#  else
-#   define strncasecmp	strnicmp
-#  endif
-#  define snprintf	_snprintf
-#  define snwprintf	_snwprintf
-#  define wcsicmp	_wcsicmp
-#  define wcsnicmp	_wcsnicmp
+#   define snprintf	_snprintf
+#   define vsnprintf	_vsnprintf
+#   define snwprintf	_snwprintf
+#   define wcsicmp	_wcsicmp
+#   define wcsnicmp	_wcsnicmp
 #else
-#  define stricmp	strcasecmp
-#  define strnicmp	strncasecmp
+#   define stricmp	strcasecmp
+#   define strnicmp	strncasecmp
 
-#  if defined(PJ_NATIVE_STRING_IS_UNICODE) && PJ_NATIVE_STRING_IS_UNICODE!=0
-#     error "Implement Unicode string functions"
-#  endif
+#   if defined(PJ_NATIVE_STRING_IS_UNICODE) && PJ_NATIVE_STRING_IS_UNICODE!=0
+#	error "Implement Unicode string functions"
+#   endif
 #endif
-
 
 #define pj_ansi_strcmp		strcmp
@@ -60,4 +57,5 @@
 #define pj_ansi_strlen		strlen
 #define pj_ansi_strcpy		strcpy
+#define pj_ansi_strncpy		strncpy
 #define pj_ansi_strcat		strcat
 #define pj_ansi_strstr		strstr
@@ -69,4 +67,6 @@
 #define pj_ansi_sprintf		sprintf
 #define pj_ansi_snprintf	snprintf
+#define pj_ansi_vsprintf	vsprintf
+#define pj_ansi_vsnprintf	vsnprintf
 
 #define pj_unicode_strcmp	wcscmp
@@ -74,4 +74,5 @@
 #define pj_unicode_strlen	wcslen
 #define pj_unicode_strcpy	wcscpy
+#define	pj_unicode_strncpy	wcsncpy
 #define pj_unicode_strcat	wcscat
 #define pj_unicode_strstr	wcsstr
@@ -83,5 +84,6 @@
 #define pj_unicode_sprintf	swprintf
 #define pj_unicode_snprintf	snwprintf
-
+#define pj_unicode_vsprintf	vswprintf
+#define pj_unicode_vsnprintf	vsnwprintf
 
 #if defined(PJ_NATIVE_STRING_IS_UNICODE) && PJ_NATIVE_STRING_IS_UNICODE!=0
@@ -90,4 +92,5 @@
 #   define pj_native_strlen	    pj_unicode_strlen
 #   define pj_native_strcpy	    pj_unicode_strcpy
+#   define pj_native_strncpy	    pj_unicode_strncpy
 #   define pj_native_strcat	    pj_unicode_strcat
 #   define pj_native_strstr	    pj_unicode_strstr
@@ -99,4 +102,6 @@
 #   define pj_native_sprintf	    pj_unicode_sprintf
 #   define pj_native_snprintf	    pj_unicode_snprintf
+#   define pj_native_vsprintf	    pj_unicode_vsprintf
+#   define pj_native_vsnprintf	    pj_unicode_vsnprintf
 #else
 #   define pj_native_strcmp	    pj_ansi_strcmp
@@ -104,4 +109,5 @@
 #   define pj_native_strlen	    pj_ansi_strlen
 #   define pj_native_strcpy	    pj_ansi_strcpy
+#   define pj_native_strncpy	    pj_ansi_strncpy
 #   define pj_native_strcat	    pj_ansi_strcat
 #   define pj_native_strstr	    pj_ansi_strstr
@@ -113,4 +119,6 @@
 #   define pj_native_sprintf	    pj_ansi_sprintf
 #   define pj_native_snprintf	    pj_ansi_snprintf
+#   define pj_native_vsprintf	    pj_ansi_vsprintf
+#   define pj_native_vsnprintf	    pj_ansi_vsnprintf
 #endif
 
Index: /pjproject/trunk/pjlib/include/pj/string.h
===================================================================
--- /pjproject/trunk/pjlib/include/pj/string.h	(revision 314)
+++ /pjproject/trunk/pjlib/include/pj/string.h	(revision 315)
@@ -27,6 +27,4 @@
 #include <pj/types.h>
 #include <pj/compat/string.h>
-#include <pj/compat/sprintf.h>
-#include <pj/compat/vsprintf.h>
 
 
Index: /pjproject/trunk/pjlib/src/pj/config.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/config.c	(revision 314)
+++ /pjproject/trunk/pjlib/src/pj/config.c	(revision 315)
@@ -22,5 +22,5 @@
 
 static const char *id = "config.c";
-const char *PJ_VERSION = "0.5.4";
+const char *PJ_VERSION = "0.5.4.1";
 
 PJ_DEF(void) pj_dump_config(void)
Index: /pjproject/trunk/pjlib/src/pj/errno.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/errno.c	(revision 314)
+++ /pjproject/trunk/pjlib/src/pj/errno.c	(revision 315)
@@ -20,5 +20,4 @@
 #include <pj/string.h>
 #include <pj/assert.h>
-#include <pj/compat/sprintf.h>
 
 /* Prototype for platform specific error message, which will be defined 
@@ -142,5 +141,5 @@
 
     if (statcode < PJ_ERRNO_START + PJ_ERRNO_SPACE_SIZE) {
-        len = pj_snprintf( buf, bufsize, "Unknown error %d", statcode);
+        len = pj_ansi_snprintf( buf, bufsize, "Unknown error %d", statcode);
 
     } else if (statcode < PJ_ERRNO_START_STATUS + PJ_ERRNO_SPACE_SIZE) {
Index: /pjproject/trunk/pjlib/src/pj/log.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/log.c	(revision 314)
+++ /pjproject/trunk/pjlib/src/pj/log.c	(revision 315)
@@ -21,5 +21,4 @@
 #include <pj/string.h>
 #include <pj/os.h>
-#include <pj/compat/vsprintf.h>
 #include <pj/compat/stdarg.h>
 
@@ -89,5 +88,5 @@
 	static const char *wdays[] = { "Sun", "Mon", "Tue", "Wed",
 				       "Thu", "Fri", "Sat"};
-	strcpy(pre, wdays[ptime.wday]);
+	pj_ansi_strcpy(pre, wdays[ptime.wday]);
 	pre += 3;
     }
@@ -138,8 +137,9 @@
 
     /* Print the whole message to the string log_buffer. */
-    print_len = vsnprintf(pre, sizeof(log_buffer)-len, format, marker);
+    print_len = pj_ansi_vsnprintf(pre, sizeof(log_buffer)-len, format, 
+				  marker);
     if (print_len < 0) {
-	print_len = pj_snprintf(pre, sizeof(log_buffer)-len, 
-				"<logging error: msg too long>");
+	print_len = pj_ansi_snprintf(pre, sizeof(log_buffer)-len, 
+				     "<logging error: msg too long>");
     }
     len = len + print_len;
Index: /pjproject/trunk/pjlib/src/pj/os_core_win32.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/os_core_win32.c	(revision 314)
+++ /pjproject/trunk/pjlib/src/pj/os_core_win32.c	(revision 315)
@@ -24,6 +24,4 @@
 #include <pj/rand.h>
 #include <pj/assert.h>
-#include <pj/compat/vsprintf.h>
-#include <pj/compat/sprintf.h>
 #include <pj/errno.h>
 #include <pj/except.h>
@@ -231,7 +229,7 @@
 
     if (cstr_thread_name && pj_strlen(&thread_name) < sizeof(thread->obj_name)-1)
-	pj_sprintf(thread->obj_name, cstr_thread_name, thread->idthread);
+	pj_ansi_sprintf(thread->obj_name, cstr_thread_name, thread->idthread);
     else
-	pj_sprintf(thread->obj_name, "thr%p", (void*)thread->idthread);
+	pj_ansi_sprintf(thread->obj_name, "thr%p", (void*)thread->idthread);
     
     rc = pj_thread_local_set(thread_tls_id, thread);
@@ -310,7 +308,7 @@
 
     if (strchr(thread_name, '%')) {
-	pj_snprintf(rec->obj_name, PJ_MAX_OBJ_NAME, thread_name, rec);
+	pj_ansi_snprintf(rec->obj_name, PJ_MAX_OBJ_NAME, thread_name, rec);
     } else {
-	strncpy(rec->obj_name, thread_name, PJ_MAX_OBJ_NAME);
+	pj_ansi_strncpy(rec->obj_name, thread_name, PJ_MAX_OBJ_NAME);
 	rec->obj_name[PJ_MAX_OBJ_NAME-1] = '\0';
     }
@@ -689,7 +687,7 @@
     }
     if (strchr(name, '%')) {
-	pj_snprintf(mutex->obj_name, PJ_MAX_OBJ_NAME, name, mutex);
+	pj_ansi_snprintf(mutex->obj_name, PJ_MAX_OBJ_NAME, name, mutex);
     } else {
-	strncpy(mutex->obj_name, name, PJ_MAX_OBJ_NAME);
+	pj_ansi_strncpy(mutex->obj_name, name, PJ_MAX_OBJ_NAME);
 	mutex->obj_name[PJ_MAX_OBJ_NAME-1] = '\0';
     }
@@ -1045,7 +1043,7 @@
     }
     if (strchr(name, '%')) {
-	pj_snprintf(sem->obj_name, PJ_MAX_OBJ_NAME, name, sem);
+	pj_ansi_snprintf(sem->obj_name, PJ_MAX_OBJ_NAME, name, sem);
     } else {
-	strncpy(sem->obj_name, name, PJ_MAX_OBJ_NAME);
+	pj_ansi_strncpy(sem->obj_name, name, PJ_MAX_OBJ_NAME);
 	sem->obj_name[PJ_MAX_OBJ_NAME-1] = '\0';
     }
@@ -1175,7 +1173,7 @@
     }
     if (strchr(name, '%')) {
-	pj_snprintf(event->obj_name, PJ_MAX_OBJ_NAME, name, event);
+	pj_ansi_snprintf(event->obj_name, PJ_MAX_OBJ_NAME, name, event);
     } else {
-	strncpy(event->obj_name, name, PJ_MAX_OBJ_NAME);
+	pj_ansi_strncpy(event->obj_name, name, PJ_MAX_OBJ_NAME);
 	event->obj_name[PJ_MAX_OBJ_NAME-1] = '\0';
     }
Index: /pjproject/trunk/pjlib/src/pj/os_error_win32.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/os_error_win32.c	(revision 314)
+++ /pjproject/trunk/pjlib/src/pj/os_error_win32.c	(revision 315)
@@ -20,6 +20,4 @@
 #include <pj/assert.h>
 #include <pj/compat/stdarg.h>
-#include <pj/compat/sprintf.h>
-#include <pj/compat/vsprintf.h>
 #include <pj/unicode.h>
 #include <pj/string.h>
@@ -180,5 +178,6 @@
 
     if (!len) {
-	len = snprintf( buf, bufsize, "Unknown native error %u", (unsigned)os_errcode);
+	len = pj_ansi_snprintf( buf, bufsize, "Unknown native error %u", 
+				(unsigned)os_errcode);
 	buf[len] = '\0';
     }
Index: /pjproject/trunk/pjlib/src/pj/pool.c
===================================================================
--- /pjproject/trunk/pjlib/src/pj/pool.c	(revision 314)
+++ /pjproject/trunk/pjlib/src/pj/pool.c	(revision 315)
@@ -22,5 +22,4 @@
 #include <pj/assert.h>
 #include <pj/os.h>
-#include <pj/compat/sprintf.h>
 
 /* Include inline definitions when inlining is disabled. */
@@ -149,7 +148,7 @@
     if (name) {
 	if (strchr(name, '%') != NULL) {
-	    sprintf(pool->obj_name, name, pool);
+	    pj_ansi_sprintf(pool->obj_name, name, pool);
 	} else {
-	    strncpy(pool->obj_name, name, PJ_MAX_OBJ_NAME);
+	    pj_ansi_strncpy(pool->obj_name, name, PJ_MAX_OBJ_NAME);
 	}
     } else {
Index: /pjproject/trunk/pjlib/src/pjlib-test/main.c
===================================================================
--- /pjproject/trunk/pjlib/src/pjlib-test/main.c	(revision 314)
+++ /pjproject/trunk/pjlib/src/pjlib-test/main.c	(revision 315)
@@ -22,4 +22,5 @@
 #include <pj/sock.h>
 #include <pj/log.h>
+#include <stdio.h>
 
 extern int param_echo_sock_type;
Index: /pjproject/trunk/pjmedia/src/pjmedia/errno.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/errno.c	(revision 314)
+++ /pjproject/trunk/pjmedia/src/pjmedia/errno.c	(revision 315)
@@ -170,7 +170,7 @@
     /* Error not found. */
     errstr.ptr = buf;
-    errstr.slen = pj_snprintf(buf, bufsize, 
-			      "Unknown error %d",
-			      statcode);
+    errstr.slen = pj_ansi_snprintf(buf, bufsize, 
+				   "Unknown error %d",
+				   statcode);
 
     return errstr;
Index: /pjproject/trunk/pjmedia/src/pjmedia/sdp.c
===================================================================
--- /pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 314)
+++ /pjproject/trunk/pjmedia/src/pjmedia/sdp.c	(revision 315)
@@ -291,5 +291,5 @@
     /* Get the clock rate. */
     token.ptr = (char*)p;
-    while (pj_isdigit(*p) && p != end)
+    while (p != end && pj_isdigit(*p))
 	++p;
     token.slen = p - token.ptr;
Index: /pjproject/trunk/pjsip-apps/build/pjsip_perf.dsp
===================================================================
--- /pjproject/trunk/pjsip-apps/build/pjsip_perf.dsp	(revision 314)
+++ /pjproject/trunk/pjsip-apps/build/pjsip_perf.dsp	(revision 315)
@@ -51,5 +51,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
-# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386 /out:"..\bin\pjsip-perf-i386-win32-vc6d.exe"
+# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib ole32.lib user32.lib kernel32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386 /out:"..\bin\pjsip-perf-i386-win32-vc6d.exe"
 
 !ELSEIF  "$(CFG)" == "pjsip_perf - Win32 Debug"
@@ -75,5 +75,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
-# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /profile /debug /machine:I386 /out:"..\bin\pjsip-perf-i386-win32-vc6d.exe"
+# ADD LINK32 netapi32.lib mswsock.lib ws2_32.lib ole32.lib user32.lib kernel32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /profile /debug /machine:I386 /out:"..\bin\pjsip-perf-i386-win32-vc6d.exe"
 
 !ENDIF 
Index: /pjproject/trunk/pjsip-apps/build/pjsua.dsp
===================================================================
--- /pjproject/trunk/pjsip-apps/build/pjsua.dsp	(revision 314)
+++ /pjproject/trunk/pjsip-apps/build/pjsua.dsp	(revision 315)
@@ -52,5 +52,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /machine:I386
-# ADD LINK32 dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /map /machine:I386 /out:"../bin/pjsua_vc6.exe" /fixed:no
+# ADD LINK32 dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib ole32.lib user32.lib kernel32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /map /machine:I386 /out:"../bin/pjsua_vc6.exe" /fixed:no
 # SUBTRACT LINK32 /pdb:none /debug
 
@@ -78,5 +78,5 @@
 LINK32=link.exe
 # ADD BASE LINK32 kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /pdbtype:sept
-# ADD LINK32 dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib ole32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /out:"../bin/pjsua_vc6d.exe" /pdbtype:sept
+# ADD LINK32 dsound.lib dxguid.lib netapi32.lib mswsock.lib ws2_32.lib ole32.lib user32.lib kernel32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib shell32.lib oleaut32.lib uuid.lib odbc32.lib odbccp32.lib /nologo /subsystem:console /debug /machine:I386 /out:"../bin/pjsua_vc6d.exe" /pdbtype:sept
 
 !ENDIF 
Index: /pjproject/trunk/pjsip-apps/src/pjsip-perf/main.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsip-perf/main.c	(revision 314)
+++ /pjproject/trunk/pjsip-apps/src/pjsip-perf/main.c	(revision 315)
@@ -21,5 +21,5 @@
 #include <stdlib.h>		/* atoi */
 
-//#define THIS_FILE   "main.c"
+#define THIS_FILE   "main.c"
 
 pjsip_perf_settings settings;
Index: /pjproject/trunk/pjsip-apps/src/pjsua/main.c
===================================================================
--- /pjproject/trunk/pjsip-apps/src/pjsua/main.c	(revision 314)
+++ /pjproject/trunk/pjsip-apps/src/pjsua/main.c	(revision 315)
@@ -19,5 +19,5 @@
 #include <pjsua-lib/pjsua.h>
 #include <stdlib.h>		/* atoi */
-
+#include <stdio.h>
 
 #define THIS_FILE	"main.c"
@@ -206,17 +206,19 @@
 
 	pjsip_regc_info info;
+	const pj_str_t *status_str;
 
 	pjsip_regc_get_info(pjsua.acc[acc_index].regc, &info);
 
-	pj_snprintf(reg_status, sizeof(reg_status),
-		    "%s (%.*s;expires=%d)",
-		    pjsip_get_status_text(pjsua.acc[acc_index].reg_last_code)->ptr,
-		    (int)info.client_uri.slen,
-		    info.client_uri.ptr,
-		    info.next_reg);
+	status_str = pjsip_get_status_text(pjsua.acc[acc_index].reg_last_code);
+	pj_ansi_snprintf(reg_status, sizeof(reg_status),
+			 "%s (%.*s;expires=%d)",
+			 status_str->ptr,
+			 (int)info.client_uri.slen,
+			 info.client_uri.ptr,
+			 info.next_reg);
 
     } else {
-	pj_sprintf(reg_status, "in progress (%d)", 
-		   pjsua.acc[acc_index].reg_last_code);
+	pj_ansi_sprintf(reg_status, "in progress (%d)", 
+		        pjsua.acc[acc_index].reg_last_code);
     }
 
@@ -386,5 +388,5 @@
 	    char s[10];
 	    if (port_info->listener[j]) {
-		pj_sprintf(s, "#%d ", j);
+		pj_ansi_sprintf(s, "#%d ", j);
 		pj_ansi_strcat(txlist, s);
 	    }
Index: /pjproject/trunk/pjsip/src/pjsip-simple/errno.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-simple/errno.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip-simple/errno.c	(revision 315)
@@ -96,7 +96,7 @@
     /* Error not found. */
     errstr.ptr = buf;
-    errstr.slen = pj_snprintf(buf, bufsize, 
-			      "Unknown error %d",
-			      statcode);
+    errstr.slen = pj_ansi_snprintf(buf, bufsize, 
+				   "Unknown error %d",
+ 				   statcode);
 
     return errstr;
Index: /pjproject/trunk/pjsip/src/pjsip-simple/evsub.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-simple/evsub.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip-simple/evsub.c	(revision 315)
@@ -667,6 +667,6 @@
 
     /* Set name. */
-    pj_snprintf(sub->obj_name, PJ_ARRAY_SIZE(sub->obj_name),
-		"evsub%p", sub);
+    pj_ansi_snprintf(sub->obj_name, PJ_ARRAY_SIZE(sub->obj_name),
+		     "evsub%p", sub);
 
 
Index: /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip-ua/sip_inv.c	(revision 315)
@@ -396,5 +396,5 @@
 
     /* Object name will use the same dialog pointer. */
-    pj_snprintf(inv->obj_name, PJ_MAX_OBJ_NAME, "inv%p", dlg);
+    pj_ansi_snprintf(inv->obj_name, PJ_MAX_OBJ_NAME, "inv%p", dlg);
 
     /* Create negotiator if local_sdp is specified. */
@@ -794,5 +794,5 @@
 
     /* Object name will use the same dialog pointer. */
-    pj_snprintf(inv->obj_name, PJ_MAX_OBJ_NAME, "inv%p", dlg);
+    pj_ansi_snprintf(inv->obj_name, PJ_MAX_OBJ_NAME, "inv%p", dlg);
 
     /* Parse SDP in message body, if present. */
Index: /pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_auth_client.c	(revision 315)
@@ -229,5 +229,5 @@
 	cred->qop = pjsip_AUTH_STR;
 	cred->nc.ptr = pj_pool_alloc(pool, 16);
-	pj_snprintf(cred->nc.ptr, 16, "%06u", nc);
+	pj_ansi_snprintf(cred->nc.ptr, 16, "%06u", nc);
 
 	if (cnonce && cnonce->slen) {
Index: /pjproject/trunk/pjsip/src/pjsip/sip_dialog.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_dialog.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_dialog.c	(revision 315)
@@ -74,5 +74,5 @@
 
     dlg->pool = pool;
-    pj_sprintf(dlg->obj_name, "dlg%p", dlg);
+    pj_ansi_sprintf(dlg->obj_name, "dlg%p", dlg);
     dlg->ua = ua;
     dlg->endpt = endpt;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 315)
@@ -901,10 +901,10 @@
 
 	pj_ansi_strcpy(newformat, format);
-	pj_snprintf(newformat+len, sizeof(newformat)-len-1,
-		    ": [err %d] ", error_code);
+	pj_ansi_snprintf(newformat+len, sizeof(newformat)-len-1,
+			 ": [err %d] ", error_code);
 	len += pj_ansi_strlen(newformat+len);
 
-	errstr = pjsip_strerror(error_code, newformat+len, 
-				sizeof(newformat)-len-1);
+	errstr = pj_strerror( error_code, newformat+len, 
+			      sizeof(newformat)-len-1);
 
 	len += errstr.slen;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_errno.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_errno.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_errno.c	(revision 315)
@@ -148,7 +148,7 @@
 	    /* Error not found. */
 	    errstr.ptr = buf;
-	    errstr.slen = pj_snprintf(buf, bufsize, 
-				      "Unknown error %d",
-				      statcode);
+	    errstr.slen = pj_ansi_snprintf(buf, bufsize, 
+					   "Unknown error %d",
+					   statcode);
 
 	    return errstr;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_msg.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 315)
@@ -1716,7 +1716,7 @@
 				     host->slen + 2 +	/* host */
 				     text->slen + 2);	/* text */
-    hvalue.slen = pj_sprintf(hvalue.ptr, "%u %.*s \"%.*s\"",
-			     code, (int)host->slen, host->ptr,
-			     (int)text->slen, text->ptr);
+    hvalue.slen = pj_ansi_sprintf(hvalue.ptr, "%u %.*s \"%.*s\"",
+				  code, (int)host->slen, host->ptr,
+				  (int)text->slen, text->ptr);
 
     return pjsip_generic_string_hdr_create(pool, &str_warning, &hvalue);
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 315)
@@ -863,5 +863,5 @@
     tsx->endpt = mod_tsx_layer.endpt;
 
-    pj_sprintf(tsx->obj_name, "tsx%p", tsx);
+    pj_ansi_sprintf(tsx->obj_name, "tsx%p", tsx);
 
     tsx->handle_200resp = 1;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 315)
@@ -236,5 +236,5 @@
     tdata->pool = pool;
     tdata->mgr = mgr;
-    pj_snprintf(tdata->obj_name, PJ_MAX_OBJ_NAME, "tdta%p", tdata);
+    pj_ansi_snprintf(tdata->obj_name, PJ_MAX_OBJ_NAME, "tdta%p", tdata);
 
     status = pj_atomic_create(tdata->pool, 0, &tdata->ref_cnt);
@@ -318,16 +318,16 @@
 
     if (msg->type == PJSIP_REQUEST_MSG) {
-	len = pj_snprintf(info_buf, sizeof(info_buf), 
-			  "Request msg %.*s/cseq=%d (%s)",
-			  (int)msg->line.req.method.name.slen,
-			  msg->line.req.method.name.ptr,
-			  cseq->cseq, obj_name);
+	len = pj_ansi_snprintf(info_buf, sizeof(info_buf), 
+			       "Request msg %.*s/cseq=%d (%s)",
+			       (int)msg->line.req.method.name.slen,
+			       msg->line.req.method.name.ptr,
+			       cseq->cseq, obj_name);
     } else {
-	len = pj_snprintf(info_buf, sizeof(info_buf),
-			  "Response msg %d/%.*s/cseq=%d (%s)",
-			  msg->line.status.code,
-			  (int)cseq->method.name.slen,
-			  cseq->method.name.ptr,
-			  cseq->cseq, obj_name);
+	len = pj_ansi_snprintf(info_buf, sizeof(info_buf),
+			       "Response msg %d/%.*s/cseq=%d (%s)",
+			       msg->line.status.code,
+			       (int)cseq->method.name.slen,
+			       cseq->method.name.ptr,
+			       cseq->cseq, obj_name);
     }
 
@@ -368,5 +368,5 @@
 
     pj_ansi_strcpy(obj_name, "rdata");
-    pj_sprintf(obj_name+5, "%p", rdata);
+    pj_ansi_sprintf(obj_name+5, "%p", rdata);
 
     rdata->msg_info.info = get_msg_info(rdata->tp_info.pool, obj_name,
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_loop.c	(revision 315)
@@ -359,5 +359,5 @@
     
     /* Initialize transport properties. */
-    pj_sprintf(loop->base.obj_name, "loop%p", loop);
+    pj_ansi_sprintf(loop->base.obj_name, "loop%p", loop);
     loop->base.pool = pool;
     status = pj_atomic_create(pool, 0, &loop->base.ref_cnt);
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport_udp.c	(revision 315)
@@ -402,5 +402,5 @@
 
     /* Object name. */
-    pj_sprintf(tp->base.obj_name, "udp%p", tp);
+    pj_ansi_sprintf(tp->base.obj_name, "udp%p", tp);
 
     /* Init reference counter. */
@@ -446,9 +446,10 @@
     /* Transport info. */
     tp->base.info = pj_pool_alloc(pool, 80);
-    pj_sprintf(tp->base.info, "udp %s:%d [published as %s:%d]",
-			      pj_inet_ntoa(((pj_sockaddr_in*)&tp->base.local_addr)->sin_addr),
-			      pj_ntohs(((pj_sockaddr_in*)&tp->base.local_addr)->sin_port),
-			      tp->base.local_name.host.ptr,
-			      tp->base.local_name.port);
+    pj_ansi_sprintf( 
+	tp->base.info, "udp %s:%d [published as %s:%d]",
+	pj_inet_ntoa(((pj_sockaddr_in*)&tp->base.local_addr)->sin_addr),
+	pj_ntohs(((pj_sockaddr_in*)&tp->base.local_addr)->sin_port),
+	tp->base.local_name.host.ptr,
+	tp->base.local_name.port);
 
     /* Set endpoint. */
Index: /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 315)
@@ -766,7 +766,7 @@
 	userinfo[len] = '\0';
     
-    len = pj_snprintf(buf, size, "%s[%s]  %s",
-		      title,
-		      (dlg->state==PJSIP_DIALOG_STATE_NULL ? " - " :
+    len = pj_ansi_snprintf(buf, size, "%s[%s]  %s",
+			   title,
+			   (dlg->state==PJSIP_DIALOG_STATE_NULL ? " - " :
 							     "est"),
 		      userinfo);
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_core.c	(revision 315)
@@ -897,5 +897,5 @@
 
 		/* With the user part. */
-		len = pj_snprintf(contact, sizeof(contact),
+		len = pj_ansi_snprintf(contact, sizeof(contact),
 				  "<sip:%.*s@%.*s:%d>",
 				  (int)sip_uri->user.slen,
@@ -908,5 +908,5 @@
 		/* Without user part */
 
-		len = pj_snprintf(contact, sizeof(contact),
+		len = pj_ansi_snprintf(contact, sizeof(contact),
 				  "<sip:%.*s:%d>",
 				  (int)udp_transport->local_name.host.slen,
Index: /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_settings.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_settings.c	(revision 314)
+++ /pjproject/trunk/pjsip/src/pjsua-lib/pjsua_settings.c	(revision 315)
@@ -19,4 +19,5 @@
 #include <pjsua-lib/pjsua.h>
 #include <pjsua-lib/getopt.h>
+#include <stdio.h>
 
 /*
@@ -594,8 +595,8 @@
 	userinfo[len] = '\0';
     
-    len = pj_snprintf(buf, size, "%s[%s] %s",
-		      title,
-		      pjsua_inv_state_names[inv->state],
-		      userinfo);
+    len = pj_ansi_snprintf(buf, size, "%s[%s] %s",
+			   title,
+			   pjsua_inv_state_names[inv->state],
+			   userinfo);
     if (len < 1 || len >= (int)size) {
 	pj_ansi_strcpy(buf, "<--uri too long-->");
